unit Democal;
{ Demo program written to demonstrate (and debug) the use of TMathControl.
  Four level stack (advanced: real and complex numbers) scientific RPN calculator.
  Copyright  1996, John Merrit (Analog Species in a Digital World Productions).
  All Rights Reserved.
  Contact: john.merrit@NET4ALL.BE
  If you recompile this (using Borland Delphi), the resulting *.exe will NOT do
  much usefull!
  Some (important) code has been removed to preserve (illegal) copying of my work.
  NOTE:
  Property CalcAccuracy is NOT implemented in this unregistered version.      }
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Testmath, Menus, MathCont;

type

  TCalForm = class(TForm)
    RPNScreen: TMemo;
    TanBut: TButton;
    ThreeBut: TButton;
    EightBut: TButton;
    FourBut: TButton;
    SepBut: TButton;
    NilBut: TButton;
    OneBut: TButton;
    NineBut: TButton;
    SixBut: TButton;
    TwoBut: TButton;
    FiveBut: TButton;
    DivBut: TButton;
    AddBut: TButton;
    SevenBut: TButton;
    ClearBut: TButton;
    MultBut: TButton;
    MinusBut: TButton;
    SinBut: TButton;
    XToYBut: TButton;
    LogBut: TButton;
    LnBut: TButton;
    CosBut: TButton;
    TanhBut: TButton;
    CoshBut: TButton;
    SinhBut: TButton;
    ArgBut: TButton;
    SqrBut: TButton;
    AbsBut: TButton;
    EnterBut: TButton;
    SwapBut: TButton;
    DropBut: TButton;
    RotateBut: TButton;
    RightBBut: TButton;
    SemiCBut: TButton;
    LeftBBut: TButton;
    NegBut: TButton;
    Panel1: TPanel;
    ConjBut: TButton;
    PiBut: TButton;
    eBut: TButton;
    iBut: TButton;
    InvBut: TButton;
    FacultyBut: TButton;
    GreenCheck: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    RTOCBut: TButton;
    CTORBut: TButton;
    DTORBut: TButton;
    RTODBut: TButton;
    CombBut: TButton;
    PermBut: TButton;
    MainMenu1: TMainMenu;
    Custom1: TMenuItem;
    Color1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    About1: TMenuItem;
    Author1: TMenuItem;
    Color2nd1: TMenuItem;
    Label12: TLabel;
    Panel2: TPanel;
    MathControl1: TMathControl;
    procedure Clear(Sender: TObject);
    procedure EnterButClick(Sender: TObject);
    procedure NumBut(Sender: TObject);
    procedure DropButClick(Sender: TObject);
    procedure SwapButClick(Sender: TObject);
    procedure RotateButClick(Sender: TObject);
    procedure Arithm(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AFunc(Sender: TObject);
    procedure Constants(Sender: TObject);
    procedure GreenCheckClick(Sender: TObject);
    procedure CTORClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Color1Click(Sender: TObject);
    procedure Author1Click(Sender: TObject);
    procedure Color2nd1Click(Sender: TObject);
    procedure InvalidOp(Sender: TObject);
    procedure Overflow(Sender: TObject);
    procedure Underflow(Sender: TObject);
    procedure ZeroDivide(Sender: TObject);
    

  private
    { Private declarations }
    procedure ClearError(ErNum: integer);
    procedure WriteResult(FResult: complex);
    function GetArgument(Linenr: integer): complex;
  public
    { Public declarations }
  end;

var
  CalForm: TCalForm;
  Operand1: String;
  InvFunc: boolean;
implementation

{$R *.DFM}

{ If an error occurs, write appropriate message to the calculatorscreen. }
procedure TCalForm.ClearError(ErNum: integer);
begin
    case ErNum of
    1:RPNScreen.Lines[0]:= 'Error! Too few arguments.';
    2:RPNScreen.Lines[0]:= 'Error! Infinite result.';
    3:RPNScreen.Lines[0]:= 'Error! Invalid argument.';
    4:RPNScreen.Lines[0]:= 'Error! Invalid Operation.';
    5:RPNScreen.Lines[0]:= 'Error! Underflow.';
    6:RPNScreen.Lines[0]:= 'Error! Zero Division.';
    end;
    RPNScreen.Lines[1]:= 'Press Clear.';
    { Disable userinput until clear is pressed. }
     EnterBut.enabled:= false;
    end;

{ Clear calculatorscreen. }
procedure TCalForm.Clear(Sender: TObject);
begin
    { This code is removed by J. Merrit }
   end;

procedure TCalForm.EnterButClick(Sender: TObject);
begin
  { This code is removed by J. Merrit }
end;

{ Write result to calculatorscreen.  }
procedure TCalForm.WriteResult(FResult: complex);
begin
    { This code is removed by J. Merrit }
end;

{ Get argument from calculatorscreen and validate.  }
function TCalForm.GetArgument(Linenr: integer): complex;  { Not for the public! }
begin
    { This code is removed by J. Merrit }
 end;

{ Create number from userinput. }
procedure TCalForm.NumBut(Sender: TObject);
begin
     if Sender = SepBut then
       begin
           Operand1:= Operand1 +  ',';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = LeftBBut then
       begin
           Operand1:= Operand1 +  '(';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = SemiCBut then
       begin
           Operand1:= Operand1 +  ';';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = RightBBut then
       begin
           Operand1:= Operand1 +  ')';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = NilBut then
       begin
           Operand1:= Operand1 +  '0';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = OneBut then
       begin
           Operand1:= Operand1 +  '1';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = TwoBut then
       begin
            Operand1:= Operand1 +  '2';
            RPNScreen.lines[3]:= Operand1;
            end
       else if Sender = ThreeBut then
       begin
            Operand1:= Operand1 +  '3';
            RPNScreen.lines[3]:= Operand1;
            end
       else if Sender = FourBut then
       begin
           Operand1:= Operand1 +  '4';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = FiveBut then
       begin
            Operand1:= Operand1 +  '5';
            RPNScreen.lines[3]:= Operand1;
            end
       else if Sender = SixBut then
       begin
            Operand1:= Operand1 +  '6';
            RPNScreen.lines[3]:= Operand1;
            end
       else if Sender = SevenBut then
       begin
           Operand1:= Operand1 +  '7';
           RPNScreen.lines[3]:= Operand1;
           end
       else if Sender = EightBut then
       begin
            Operand1:= Operand1 +  '8';
            RPNScreen.lines[3]:= Operand1;
            end
       else if Sender = NineBut then
       begin
            Operand1:= Operand1 +  '9';
            RPNScreen.lines[3]:= Operand1;
            end;
end;

procedure TCalForm.DropButClick(Sender: TObject);
begin
  { This code is removed by J. Merrit }
end;

procedure TCalForm.SwapButClick(Sender: TObject);
begin
  { This code is removed by J. Merrit }
end;

procedure TCalForm.RotateButClick(Sender: TObject);
begin
   { This code is removed by J. Merrit }
end;

{ The control uses two (runtime only) complex numbers (cscalar and cscalar2) as it's variables. 
  The following code does arithmetic for functions that require two arguments.                   } 
procedure TCalForm.Arithm(Sender: TObject);
var ErrorOc: Boolean;
begin
     ErrorOc:= false;
     if RPNScreen.Lines[3] = '' then
     begin
     if ((RPNScreen.Lines[2] = '') or (RPNScreen.Lines[1] = '')) then
     begin
     ClearError(1);
     ErrorOc:= true;
     end else
     begin
     MathControl1.cscalar:= GetArgument(1);
     MathControl1.cscalar2:= GetArgument(2);
     DropButClick(sender);
     end;
     end else
     begin
     if RPNScreen.Lines[2] = '' then
     begin
     ClearError(1);
     ErrorOc:= true;
     end
     else
     begin
     MathControl1.cscalar:= GetArgument(2);
     MathControl1.cscalar2:= GetArgument(3);
     { }
     DropButClick(sender);
     { }
     end;
     end;
     if ErrorOc = false then
     begin
     DropButClick(sender);
     if Sender = AddBut then
     begin
      MathControl1.MathFunc:= fdAdd;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = MinusBut then
     begin
      MathControl1.MathFunc:= fdSubtract;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = MultBut then
     begin
      MathControl1.MathFunc:= fdMultiply;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = DivBut then
     begin
       MathControl1.MathFunc:= fdDivide;
       WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
       end else
       if Sender = RTOCBut then
     begin
      MathControl1.cscalar.im:= MathControl1.cscalar2.re;
      WriteResult(MathControl1.cscalar);
      end else
      if Sender = XToYBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdXPowerY else
      MathControl1.MathFunc:= fdXRootY;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = CombBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdCombinations else
      MathControl1.MathFunc:= fdPercent;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = PermBut then
     begin
      MathControl1.MathFunc:= fdPermutations;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end;
    end;
end;

{ The control uses two (runtime only) complex numbers (cscalar and cscalar2) as it's variables. 
  The following code does arithmetic for functions that require one argument.                   } 
procedure TCalForm.AFunc(Sender: TObject);
var ErrorOc: Boolean;
begin
      ErrorOc:= false;
     if RPNScreen.Lines[3] = '' then
     begin
     if RPNScreen.Lines[2] = '' then
     begin
     ClearError(1);
     ErrorOc:= true;
     end else
     begin
     MathControl1.cscalar:= GetArgument(2);
     DropButClick(Sender);
     end;
     end else
     begin
     MathControl1.cscalar:= GetArgument(3);
     end;
     if ErrorOc = false then
     begin
     if Sender = NegBut then
     begin
      MathControl1.MathFunc:= fdNegative;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = ArgBut then
     begin
      MathControl1.MathFunc:= fdArgument;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = AbsBut then
     begin
      MathControl1.MathFunc:= fdAbsVal;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = SqrBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdSqr
      else MathControl1.MathFunc:= fdSqrt;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = ConjBut then
     begin
      MathControl1.MathFunc:= fdConjugate;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = DTORBut then
     begin
      MathControl1.cscalar.im:= 0;
      MathControl1.MathFunc:= fdDegToRad;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
     if Sender = RTODBut then
     begin
      MathControl1.cscalar.im:= 0;
      MathControl1.MathFunc:= fdRadToDeg;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = FacultyBut then
     begin
      MathControl1.MathFunc:= fdFaculty;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = SinBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdSin
      else MathControl1.MathFunc:= fdArcSin;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = CosBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdCos
      else MathControl1.MathFunc:= fdArcCos;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = TanBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdTan
      else MathControl1.MathFunc:= fdArcTan;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = SinhBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdSinh
      else MathControl1.MathFunc:= fdArcSinh;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = CoshBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdCosh
      else MathControl1.MathFunc:= fdArcCosh;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = TanhBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdTanh
      else MathControl1.MathFunc:= fdArcTanh;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = LogBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdLog
      else MathControl1.MathFunc:= fdALog;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = LnBut then
     begin
      if InvFunc = false then
      MathControl1.MathFunc:= fdLn
      else MathControl1.MathFunc:= fdExp;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end else
      if Sender = InvBut then
     begin
      MathControl1.MathFunc:= fdInverse;
      WriteResult(MathControl1.ReturnMathFuncResult(MathControl1.Mathfunc));
      end;
    end;
end;

{ The constants Pi, e and i are not defined in the control itself. }
procedure TCalForm.Constants(Sender: TObject);
begin
   if Sender = PiBut then
   begin
   Operand1:= FloatToStr(Pi);
   EnterButClick(Sender);
   end
   else if Sender = eBut then
   begin
   Operand1:= FloatToStr(Exp(1));
   EnterButClick(Sender);
   end
   else
   begin
   Operand1:= '(' + FloatToStr(0) + ';' + FloatToStr(1) + ')';
   EnterButClick(Sender);
  end;
end;

procedure TCalForm.FormActivate(Sender: TObject);
begin
   RPNScreen.Lines[0]:= '';
   RPNScreen.Lines[1]:= '';
   RPNScreen.Lines[2]:= '';
   RPNScreen.Lines[3]:= '';
   InvFunc:= false;
end;

{If the user wants to use the 2nd functions (in green, atleast on startup)... }
procedure TCalForm.GreenCheckClick(Sender: TObject);
begin
  if GreenCheck.Checked then
  InvFunc:= true
  else
  InvFunc:= false;
  end;

{ Convert a complex to 2 real numbers... 
  (i.e. (a + bi) to a and b)              }
procedure TCalForm.CTORClick(Sender: TObject);
var c1,c2: complex;
    ErrorOc: Boolean;
begin
     ErrorOc:= false;
     if RPNScreen.Lines[3] = '' then
     begin
     if RPNScreen.Lines[2] = '' then
     begin
     ClearError(1);
     ErrorOc:= true;
     end else
     begin
     MathControl1.cscalar:= GetArgument(2);
     DropButClick(Sender);
     end;
     end else
     begin
     MathControl1.cscalar:= GetArgument(3);
     end;
     if ErrorOc = false then
     begin
     c1.re:= MathControl1.cscalar.re;
     c1.im:= 0;
     WriteResult(c1);
     c2.re:= MathControl1.cscalar.im;
     c2.im:= 0;
     WriteResult(c2);
     end;

end;

procedure TCalForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

{ Give the user some customizing options (color)... }
procedure TCalForm.Color1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
  CalForm.Color:= ColorDialog1.Color;
  Panel1.Color:= ColorDialog1.Color;
  Panel2.Color:= ColorDialog1.Color;
  end;
end;

{ To preserve space, I'm not gonna write an Aboutbox but to give myself
  an ego trip...                                                          }
procedure TCalForm.Author1Click(Sender: TObject);
begin
  MessageDlg('Demoprogram for TMathControl. Copyright 1996 John Merrit.' +
             ' Analog Species in a Digital World Productions.', mtInformation,
      [mbOk], 0);
end;

{ Give the user some customizing options (color)... }
procedure TCalForm.Color2nd1Click(Sender: TObject);
var i: integer;
begin
     if ColorDialog1.Execute then
  begin
    GreenCheck.Font.Color:= ColorDialog1.Color;
    {Thanks Lloyd (whoever you may be) for this trick!}
    for i:= 1 to 12 do
    with CalForm.FindComponent('Label' + IntToStr(i)) as TLabel do
    Font.Color:= ColorDialog1.Color;
    end;
end;

{ Errortrapping...  }
procedure TCalForm.InvalidOp(Sender: TObject);
begin
    ClearError(4);
  Abort;
end;

procedure TCalForm.Overflow(Sender: TObject);
begin
   ClearError(2);
  Abort;
end;

procedure TCalForm.Underflow(Sender: TObject);
begin
     ClearError(5);
  Abort;
end;

procedure TCalForm.ZeroDivide(Sender: TObject);
begin
    ClearError(6);
  Abort;
end;

end.
